#!/usr/bin/env python

import sys, os, getopt

Usage = "Usage: %s <input map1> <input map2> <output fsc file> [--resize=<n>] [--apix=<angstrom per pixel>] [--cpu=<n>] [--verbose]" % ( sys.argv[0] )

cpu		=	1
apix	=	0.0
verbose	=	0
resize	=	0

if len(sys.argv)<4:
	print Usage
	sys.exit(1)
else: 	
	try:
		optlist, junks = getopt.getopt(sys.argv[4:], 'c:v', ['cpu=','resize=','apix=','verbose'])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	
	for o, a in optlist:
		if o in ("-c", "--cpu"):
			cpu = int( a )
		elif o in ("--resize",):
			resize = int( a )
		elif o in ("--apix",):
			apix = float( a )
		elif o in ("--verbose",):
			verbose = 1
	cmd="export FSC=`which fsc` ;"
	if os.environ.has_key("PBS_NODEFILE"):
		cmd=cmd+" mpirun -np %d -machinefile %s" % ( cpu, os.environ["PBS_NODEFILE"] )
	else:
		cmd=cmd+" export NODEFILE=`which mach_nodes` ; mpirun -np %d -machinefile $NODEFILE" % ( cpu )
	cmd = cmd + " $FSC %s %s %s" % (sys.argv[1],sys.argv[2],sys.argv[3])
	if resize: cmd = cmd +" resize=%d" % (resize)
	if apix: cmd = cmd +" apix=%f" % (apix)
	if verbose:
		print cmd
	try:
		os.system(cmd)
	except: raise RuntimeError("running command \"%s\"" % (cmd))

