#!/usr/bin/env python

import sys, os, getopt

Usage = "Usage: %s <input> <output> [--sym=<c?,icos,etc>] [--3fmap] [--verbose] [--mrc] [--cpu=<n>]" % ( sys.argv[0] )

cpu		=	1
verbose	=	0
cmd		=	""

if len(sys.argv)<3:
	print Usage
	sys.exit(1)
else: 	
	try:
		optlist, junks = getopt.getopt(sys.argv[3:], 'vc:s', ['verbose','cpu=','3fmap','sym=','mrc'])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	
	cmd="symmetrize %s %s" % (sys.argv[1], sys.argv[2])
	for o, a in optlist:
		if o in ("-v", "--verbose"):
			cmd += " verbose"
			verbose = 1
		elif o in ("-c", "--cpu"):
			cpu = int( a )
		elif o in ("--3fmap",):
			cmd += " 3fmap"
		elif o in ("--mrc",):
			cmd += " mrc"
		elif o in ("-s", "--sym"):
			cmd += " sym=%s" % a 
	
	import tempfile
	tempfile.tempdir = os.getcwd()
	jobfile=tempfile.mktemp("-symmetrize.runpar")
	jobfp=open(jobfile,"w")
	for c in range(cpu):
		jobfp.write("%s frac=%d/%d\n" % (cmd, c, cpu))
	jobfp.close()
	runpar_cmd="runpar proc=%d,%d file=%s" % (cpu,cpu,jobfile)
	if verbose:
		print runpar_cmd
		print cmd
	try:
		os.system(runpar_cmd)
	except: raise RuntimeError("running command \"%s\"" % (runpar_cmd))
	os.remove(jobfile)

